Index: boot/genarch/ofw_tree.c
===================================================================
--- boot/genarch/ofw_tree.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/genarch/ofw_tree.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -29,10 +29,12 @@
 #include <ofw_tree.h>
 #include <ofw.h>
+#include <ofwarch.h>
 #include <types.h>
 #include <string.h>
 #include <balloc.h>
 #include <asm.h>
-
-#define MAX_PATH_LEN	256
+#include <memstr.h>
+
+#define MAX_PATH_LEN  256
 
 static ofw_tree_node_t *ofw_tree_node_alloc(void)
@@ -49,6 +51,4 @@
 static void *ofw_tree_space_alloc(size_t size)
 {
-	char *addr;
-
 	/*
 	 * What we do here is a nasty hack :-)
@@ -61,7 +61,8 @@
 	 * behind the requested memory.
 	 */
-	addr = balloc(size + 1, size);
+	char *addr = balloc(size + 1, size);
 	if (addr)
 		addr[size] = '\0';
+	
 	return addr;
 }
@@ -75,26 +76,19 @@
  * order to prevent stack from overflowing.
  *
- * @param current_node	Pointer to uninitialized ofw_tree_node structure that
- * 			will become the memory represenation of 'current'.
- * @param parent_node	Parent ofw_tree_node structure or NULL in case of root
- * 			node.
- * @param current	OpenFirmware phandle to the current device tree node.
+ * @param current_node Pointer to uninitialized ofw_tree_node structure that
+ *                     will become the memory represenation of 'current'.
+ * @param parent_node  Parent ofw_tree_node structure or NULL in case of root
+ *                     node.
+ * @param current      OpenFirmware phandle to the current device tree node.
+ *
  */
 static void ofw_tree_node_process(ofw_tree_node_t *current_node,
     ofw_tree_node_t *parent_node, phandle current)
 {
-	static char path[MAX_PATH_LEN + 1];
-	static char name[OFW_TREE_PROPERTY_MAX_NAMELEN];
-	static char name2[OFW_TREE_PROPERTY_MAX_NAMELEN];
-	phandle peer;
-	phandle child;
-	size_t len;
-	int i;
-
 	while (current_node) {
 		/*
 		 * Initialize node.
 		 */
-		current_node->parent = parent_node;
+		current_node->parent = (ofw_tree_node_t *) balloc_rebase(parent_node);
 		current_node->peer = NULL;
 		current_node->child = NULL;
@@ -103,45 +97,51 @@
 		current_node->property = NULL;
 		current_node->device = NULL;
-	
+		
 		/*
 		 * Get the disambigued name.
 		 */
-		len = ofw_package_to_path(current, path, MAX_PATH_LEN);
+		static char path[MAX_PATH_LEN + 1];
+		size_t len = ofw_package_to_path(current, path, MAX_PATH_LEN);
 		if (len == -1)
 			return;
-	
+		
 		path[len] = '\0';
-		for (i = len - 1; i >= 0 && path[i] != '/'; i--)
-			;
-		i++;	/* do not include '/' */
-	
+		
+		/* Find last slash */
+		int i;
+		for (i = len - 1; (i >= 0) && (path[i] != '/'); i--);
+		
+		/* Do not include the slash */
+		i++;
 		len -= i;
-
-		/* add space for trailing '\0' */
-		current_node->da_name = ofw_tree_space_alloc(len + 1);
-		if (!current_node->da_name)
-			return;
-	
-		memcpy(current_node->da_name, &path[i], len);
-		current_node->da_name[len] = '\0';
-	
+		
+		/* Add space for trailing '\0' */
+		char *da_name = ofw_tree_space_alloc(len + 1);
+		if (!da_name)
+			return;
+		
+		memcpy(da_name, &path[i], len);
+		da_name[len] = '\0';
+		current_node->da_name = (char *) balloc_rebase(da_name);
+		
 		/*
 		 * Recursively process the potential child node.
 		 */
-		child = ofw_get_child_node(current);
-		if (child != 0 && child != -1) {
-			ofw_tree_node_t *child_node;
-		
-			child_node = ofw_tree_node_alloc();
+		phandle child = ofw_get_child_node(current);
+		if ((child != 0) && (child != -1)) {
+			ofw_tree_node_t *child_node = ofw_tree_node_alloc();
 			if (child_node) {
 				ofw_tree_node_process(child_node, current_node,
 				    child);
-				current_node->child = child_node;
+				current_node->child =
+				    (ofw_tree_node_t *) balloc_rebase(child_node);
 			}
 		}
-	
+		
 		/*
 		 * Count properties.
 		 */
+		static char name[OFW_TREE_PROPERTY_MAX_NAMELEN];
+		static char name2[OFW_TREE_PROPERTY_MAX_NAMELEN];
 		name[0] = '\0';
 		while (ofw_next_property(current, name, name2) == 1) {
@@ -149,50 +149,46 @@
 			memcpy(name, name2, OFW_TREE_PROPERTY_MAX_NAMELEN);
 		}
-
+		
 		if (!current_node->properties)
 			return;
-	
+		
 		/*
 		 * Copy properties.
 		 */
-		current_node->property =
+		ofw_tree_property_t *property =
 		    ofw_tree_properties_alloc(current_node->properties);
-		if (!current_node->property)
+		if (!property)
 			return;
 		
 		name[0] = '\0';
 		for (i = 0; ofw_next_property(current, name, name2) == 1; i++) {
-			size_t size;
-		
 			if (i == current_node->properties)
 				break;
-		
+			
 			memcpy(name, name2, OFW_TREE_PROPERTY_MAX_NAMELEN);
-			memcpy(current_node->property[i].name, name,
-			    OFW_TREE_PROPERTY_MAX_NAMELEN);
-			current_node->property[i].name[
-			    OFW_TREE_PROPERTY_MAX_NAMELEN] = '\0';
-
-			size = ofw_get_proplen(current, name);
-			current_node->property[i].size = size;
+			memcpy(property[i].name, name, OFW_TREE_PROPERTY_MAX_NAMELEN);
+			property[i].name[OFW_TREE_PROPERTY_MAX_NAMELEN] = '\0';
+			
+			size_t size = ofw_get_proplen(current, name);
+			property[i].size = size;
+			
 			if (size) {
-				void *buf;
-			
-				buf = ofw_tree_space_alloc(size);
-				if (current_node->property[i].value = buf) {
+				void *buf = ofw_tree_space_alloc(size);
+				if (buf) {
 					/*
 					 * Copy property value to memory node.
 					 */
-					(void) ofw_get_property(current, name,
-					    buf, size);
+					(void) ofw_get_property(current, name, buf, size);
+					property[i].value = balloc_rebase(buf);
 				}
-			} else {
-				current_node->property[i].value = NULL;
-			}
-		}
-
+			} else
+				property[i].value = NULL;
+		}
+		
 		/* Just in case we ran out of memory. */
 		current_node->properties = i;
-
+		current_node->property = (ofw_tree_property_t *) balloc_rebase(property);
+		
+		
 		/*
 		 * Iteratively process the next peer node.
@@ -202,11 +198,9 @@
 		 * risk of overflowing the stack is too real.
 		 */
-		peer = ofw_get_peer_node(current);
-		if (peer != 0 && peer != -1) {
-			ofw_tree_node_t *peer_node;
-		
-			peer_node = ofw_tree_node_alloc();
-			if (peer_node) { 
-				current_node->peer = peer_node;
+		phandle peer = ofw_get_peer_node(current);
+		if ((peer != 0) && (peer != -1)) {
+			ofw_tree_node_t *peer_node = ofw_tree_node_alloc();
+			if (peer_node) {
+				current_node->peer = (ofw_tree_node_t *) balloc_rebase(peer_node);
 				current_node = peer_node;
 				current = peer;
@@ -217,4 +211,5 @@
 			}
 		}
+		
 		/*
 		 * No more peers on this level.
@@ -226,16 +221,13 @@
 /** Construct memory representation of OpenFirmware device tree.
  *
- * @return		NULL on failure or pointer to the root node.
+ * @return NULL on failure or kernel pointer to the root node.
+ *
  */
 ofw_tree_node_t *ofw_tree_build(void)
 {
-	ofw_tree_node_t *root;
-	phandle ssm_node;
-	ofw_tree_node_t *ssm;
-	
-	root = ofw_tree_node_alloc();
+	ofw_tree_node_t *root = ofw_tree_node_alloc();
 	if (root)
 		ofw_tree_node_process(root, NULL, ofw_root);
-
+	
 	/*
 	 * The firmware client interface does not automatically include the
@@ -243,15 +235,15 @@
 	 * solution is to explicitly stick "ssm" to the OFW tree.
 	 */
-	ssm_node = ofw_find_device("/ssm@0,0");
+	phandle ssm_node = ofw_find_device("/ssm@0,0");
 	if (ssm_node != -1) {
-		ssm = ofw_tree_node_alloc();
+		ofw_tree_node_t *ssm = ofw_tree_node_alloc();
 		if (ssm) {
 			ofw_tree_node_process(ssm, root,
 			    ofw_find_device("/ssm@0,0"));
 			ssm->peer = root->child;
-			root->child = ssm;
+			root->child = (ofw_tree_node_t *) balloc_rebase(ssm);
 		}
 	}
 	
-	return root;
-}
+	return (ofw_tree_node_t *) balloc_rebase(root);
+}
Index: boot/genarch/ofw_tree.h
===================================================================
--- boot/genarch/ofw_tree.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/genarch/ofw_tree.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -33,31 +33,28 @@
 #include <ofw.h>
 
-#define OFW_TREE_PROPERTY_MAX_NAMELEN	32
-
-typedef struct ofw_tree_node ofw_tree_node_t;
-typedef struct ofw_tree_property ofw_tree_property_t;
-
-/** Memory representation of OpenFirmware device tree node. */
-struct ofw_tree_node {
-	ofw_tree_node_t *parent;
-	ofw_tree_node_t *peer;
-	ofw_tree_node_t *child;
-
-	uint32_t node_handle;			/**< Old OpenFirmware node handle. */
-
-	char *da_name;				/**< Disambigued name. */
-
-	unsigned properties;			/**< Number of properties. */
-	ofw_tree_property_t *property;
-	
-	void *device;				/**< Member used solely by the kernel. */
-};
+#define OFW_TREE_PROPERTY_MAX_NAMELEN  32
 
 /** Memory representation of OpenFirmware device tree node property. */
-struct ofw_tree_property {
+typedef struct {
 	char name[OFW_TREE_PROPERTY_MAX_NAMELEN];
 	size_t size;
 	void *value;
-};
+} ofw_tree_property_t;
+
+/** Memory representation of OpenFirmware device tree node. */
+typedef struct ofw_tree_node {
+	struct ofw_tree_node *parent;
+	struct ofw_tree_node *peer;
+	struct ofw_tree_node *child;
+	
+	uint32_t node_handle;           /**< Old OpenFirmware node handle. */
+	
+	char *da_name;                  /**< Disambigued name. */
+	
+	unsigned int properties;        /**< Number of properties. */
+	ofw_tree_property_t *property;
+	
+	void *device;                   /**< Member used solely by the kernel. */
+} ofw_tree_node_t;
 
 extern ofw_tree_node_t *ofw_tree_build(void);
Index: boot/generic/memstr.h
===================================================================
--- boot/generic/memstr.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
+++ boot/generic/memstr.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2009 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef BOOT_MEMSTR_H_
+#define BOOT_MEMSTR_H_
+
+extern void memcpy(void *dst, const void *src, unsigned int cnt);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/ia64/src/drivers/ski.c
===================================================================
--- kernel/arch/ia64/src/drivers/ski.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/arch/ia64/src/drivers/ski.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -129,5 +129,5 @@
 	
 	outdev_initialize("skiout", &skiout, &skiout_ops);
-	stdout = &skiout;
+	stdout_wire(&skiout);
 	
 	sysinfo_set_item_val("fb", NULL, false);
Index: kernel/arch/ppc32/include/boot/boot.h
===================================================================
--- kernel/arch/ppc32/include/boot/boot.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/arch/ppc32/include/boot/boot.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -41,12 +41,13 @@
 #define TEMP_STACK_SIZE  0x1000
 
-#define TASKMAP_MAX_RECORDS  32
-#define MEMMAP_MAX_RECORDS   32
+#define TASKMAP_MAX_RECORDS        32
+#define MEMMAP_MAX_RECORDS         32
+#define BOOTINFO_TASK_NAME_BUFLEN  32
 
 #ifndef __ASM__
 
-#define BOOTINFO_TASK_NAME_BUFLEN 32
-
 #include <arch/types.h>
+#include <config.h>
+#include <genarch/ofw/ofw_tree.h>
 
 typedef struct {
@@ -73,21 +74,8 @@
 
 typedef struct {
-	uintptr_t addr;
-	unsigned int width;
-	unsigned int height;
-	unsigned int bpp;
-	unsigned int scanline;
-} screen_t;
-
-typedef struct {
-	uintptr_t addr;
-	unsigned int size;
-} macio_t;
-
-typedef struct {
 	memmap_t memmap;
 	taskmap_t taskmap;
-	screen_t screen;
-	macio_t macio;
+	ballocs_t ballocs;
+	ofw_tree_node_t *ofw_root;
 } bootinfo_t;
 
Index: kernel/arch/ppc32/src/mm/tlb.c
===================================================================
--- kernel/arch/ppc32/src/mm/tlb.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/arch/ppc32/src/mm/tlb.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -45,9 +45,4 @@
 static unsigned int seed = 10;
 static unsigned int seed_real __attribute__ ((section("K_UNMAPPED_DATA_START"))) = 42;
-
-
-#define TLB_FLUSH \
-	"tlbie %0\n" \
-	"addi %0, %0, 0x1000\n"
 
 
@@ -451,75 +446,8 @@
 		"sync\n"
 		
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
-		TLB_FLUSH
+		".rept 64\n"
+		"tlbie %0\n"
+		"addi %0, %0, 0x1000\n"
+		".endr\n"
 		
 		"eieio\n"
Index: kernel/arch/ppc32/src/ppc32.c
===================================================================
--- kernel/arch/ppc32/src/ppc32.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/arch/ppc32/src/ppc32.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -41,4 +41,6 @@
 #include <genarch/fb/fb.h>
 #include <genarch/fb/visuals.h>
+#include <genarch/ofw/ofw_tree.h>
+#include <genarch/ofw/pci.h>
 #include <userspace.h>
 #include <proc/uarg.h>
@@ -49,4 +51,5 @@
 #include <macros.h>
 #include <string.h>
+#include <print.h>
 
 #define IRQ_COUNT  64
@@ -63,9 +66,15 @@
 	
 	for (i = 0; i < min3(bootinfo.taskmap.count, TASKMAP_MAX_RECORDS, CONFIG_INIT_TASKS); i++) {
-		init.tasks[i].addr = PA2KA(bootinfo.taskmap.tasks[i].addr);
+		init.tasks[i].addr = bootinfo.taskmap.tasks[i].addr;
 		init.tasks[i].size = bootinfo.taskmap.tasks[i].size;
 		str_cpy(init.tasks[i].name, CONFIG_TASK_NAME_BUFLEN,
 		    bootinfo.taskmap.tasks[i].name);
 	}
+	
+	/* Copy boot allocations info. */
+	ballocs.base = bootinfo.ballocs.base;
+	ballocs.size = bootinfo.ballocs.size;
+	
+	ofw_tree_init(bootinfo.ofw_root);
 }
 
@@ -74,44 +83,76 @@
 	/* Initialize dispatch table */
 	interrupt_init();
-
+	
 	/* Start decrementer */
 	start_decrementer();
 }
 
+static bool display_register(ofw_tree_node_t *node, void *arg)
+{
+	uintptr_t fb_addr = 0;
+	uint32_t fb_width = 0;
+	uint32_t fb_height = 0;
+	uint32_t fb_scanline = 0;
+	unsigned int visual = VISUAL_UNKNOWN;
+	
+	ofw_tree_property_t *prop = ofw_tree_getprop(node, "address");
+	if ((prop) && (prop->value))
+		fb_addr = *((uintptr_t *) prop->value);
+	
+	prop = ofw_tree_getprop(node, "width");
+	if ((prop) && (prop->value))
+		fb_width = *((uint32_t *) prop->value);
+	
+	prop = ofw_tree_getprop(node, "height");
+	if ((prop) && (prop->value))
+		fb_height = *((uint32_t *) prop->value);
+	
+	prop = ofw_tree_getprop(node, "depth");
+	if ((prop) && (prop->value)) {
+		uint32_t fb_bpp = *((uint32_t *) prop->value);
+		switch (fb_bpp) {
+		case 8:
+			visual = VISUAL_INDIRECT_8;
+			break;
+		case 16:
+			visual = VISUAL_RGB_5_5_5_BE;
+			break;
+		case 24:
+			visual = VISUAL_BGR_8_8_8;
+			break;
+		case 32:
+			visual = VISUAL_RGB_0_8_8_8;
+			break;
+		default:
+			visual = VISUAL_UNKNOWN;
+		}
+	}
+	
+	prop = ofw_tree_getprop(node, "linebytes");
+	if ((prop) && (prop->value))
+		fb_scanline = *((uint32_t *) prop->value);
+	
+	if ((fb_addr) && (fb_width > 0) && (fb_height > 0)
+	    && (fb_scanline > 0) && (visual != VISUAL_UNKNOWN)) {
+		fb_properties_t fb_prop = {
+			.addr = fb_addr,
+			.offset = 0,
+			.x = fb_width,
+			.y = fb_height,
+			.scan = fb_scanline,
+			.visual = visual,
+		};
+		fb_init(&fb_prop);
+	}
+	
+	/* Consider only a single device for now */
+	return false;
+}
+
 void arch_post_mm_init(void)
 {
 	if (config.cpu_active == 1) {
-
 #ifdef CONFIG_FB
-		/* Initialize framebuffer */
-		if (bootinfo.screen.addr) {
-			unsigned int visual;
-			
-			switch (bootinfo.screen.bpp) {
-			case 8:
-				visual = VISUAL_INDIRECT_8;
-				break;
-			case 16:
-				visual = VISUAL_RGB_5_5_5_BE;
-				break;
-			case 24:
-				visual = VISUAL_BGR_8_8_8;
-				break;
-			case 32:
-				visual = VISUAL_RGB_0_8_8_8;
-				break;
-			default:
-				panic("Unsupported bits per pixel.");
-			}
-			fb_properties_t prop = {
-				.addr = bootinfo.screen.addr,
-				.offset = 0,
-				.x = bootinfo.screen.width,
-				.y = bootinfo.screen.height,
-				.scan = bootinfo.screen.scanline,
-				.visual = visual,
-			};
-			fb_init(&prop);
-		}
+		ofw_tree_walk_by_device_type("display", display_register, NULL);
 #endif
 		
@@ -132,21 +173,27 @@
 }
 
-void arch_post_smp_init(void)
-{
-	if (bootinfo.macio.addr) {
+static bool macio_register(ofw_tree_node_t *node, void *arg)
+{
+	ofw_pci_reg_t *assigned_address = NULL;
+	
+	ofw_tree_property_t *prop = ofw_tree_getprop(node, "assigned-addresses");
+	if ((prop) && (prop->value))
+		assigned_address = ((ofw_pci_reg_t *) prop->value);
+	
+	if (assigned_address) {
 		/* Initialize PIC */
 		cir_t cir;
 		void *cir_arg;
-		pic_init(bootinfo.macio.addr, PAGE_SIZE, &cir, &cir_arg);
-
+		pic_init(assigned_address[0].addr, PAGE_SIZE, &cir, &cir_arg);
+		
 #ifdef CONFIG_MAC_KBD
-		uintptr_t pa = bootinfo.macio.addr + 0x16000;
+		uintptr_t pa = assigned_address[0].addr + 0x16000;
 		uintptr_t aligned_addr = ALIGN_DOWN(pa, PAGE_SIZE);
 		size_t offset = pa - aligned_addr;
 		size_t size = 2 * PAGE_SIZE;
-			
+		
 		cuda_t *cuda = (cuda_t *)
 		    (hw_map(aligned_addr, offset + size) + offset);
-			
+		
 		/* Initialize I/O controller */
 		cuda_instance_t *cuda_instance =
@@ -163,4 +210,12 @@
 #endif
 	}
+	
+	/* Consider only a single device for now */
+	return false;
+}
+
+void arch_post_smp_init(void)
+{
+	ofw_tree_walk_by_device_type("mac-io", macio_register, NULL);
 }
 
Index: kernel/arch/sparc64/src/drivers/fhc.c
===================================================================
--- kernel/arch/sparc64/src/drivers/fhc.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/arch/sparc64/src/drivers/fhc.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -46,4 +46,5 @@
 #include <arch/types.h>
 #include <genarch/ofw/ofw_tree.h>
+#include <genarch/ofw/fhc.h>
 #include <sysinfo/sysinfo.h>
 
Index: kernel/arch/sparc64/src/drivers/kbd.c
===================================================================
--- kernel/arch/sparc64/src/drivers/kbd.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/arch/sparc64/src/drivers/kbd.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -35,15 +35,6 @@
 #include <arch/drivers/kbd.h>
 #include <genarch/ofw/ofw_tree.h>
-
-#ifdef CONFIG_SUN_KBD
-#include <genarch/kbrd/kbrd.h>
-#endif
-#ifdef CONFIG_Z8530
-#include <genarch/drivers/z8530/z8530.h>
-#endif
-#ifdef CONFIG_NS16550
-#include <genarch/drivers/ns16550/ns16550.h>
-#endif
-
+#include <genarch/ofw/fhc.h>
+#include <genarch/ofw/ebus.h>
 #include <console/console.h>
 #include <ddi/irq.h>
@@ -56,4 +47,16 @@
 
 #ifdef CONFIG_SUN_KBD
+#include <genarch/kbrd/kbrd.h>
+#endif
+
+#ifdef CONFIG_Z8530
+#include <genarch/drivers/z8530/z8530.h>
+#endif
+
+#ifdef CONFIG_NS16550
+#include <genarch/drivers/ns16550/ns16550.h>
+#endif
+
+#ifdef CONFIG_SUN_KBD
 
 #ifdef CONFIG_Z8530
Index: kernel/arch/sparc64/src/drivers/pci.c
===================================================================
--- kernel/arch/sparc64/src/drivers/pci.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/arch/sparc64/src/drivers/pci.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -37,4 +37,5 @@
 #include <arch/drivers/pci.h>
 #include <genarch/ofw/ofw_tree.h>
+#include <genarch/ofw/upa.h>
 #include <arch/trap/interrupt.h>
 #include <mm/page.h>
Index: kernel/arch/sparc64/src/drivers/scr.c
===================================================================
--- kernel/arch/sparc64/src/drivers/scr.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/arch/sparc64/src/drivers/scr.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -35,4 +35,7 @@
 #include <arch/drivers/scr.h>
 #include <genarch/ofw/ofw_tree.h>
+#include <genarch/ofw/pci.h>
+#include <genarch/ofw/sbus.h>
+#include <genarch/ofw/upa.h>
 #include <genarch/fb/fb.h>
 #include <genarch/fb/visuals.h>
Index: kernel/arch/sparc64/src/drivers/sgcn.c
===================================================================
--- kernel/arch/sparc64/src/drivers/sgcn.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/arch/sparc64/src/drivers/sgcn.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -380,6 +380,6 @@
 	sysinfo_set_item_val("fb.kind", NULL, 4);
 
-	outdev_initialize("sgcnout", &sgcnout, &sgcnout_ops);	
-	stdout = &sgcnout;
+	outdev_initialize("sgcnout", &sgcnout, &sgcnout_ops);
+	stdout_wire(&sgcnout);
 }
 
Index: kernel/genarch/Makefile.inc
===================================================================
--- kernel/genarch/Makefile.inc	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/Makefile.inc	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -130,10 +130,14 @@
 ifeq ($(CONFIG_OFW_TREE),y)
 	GENARCH_SOURCES += \
-		genarch/src/ofw/ofw_tree.c \
+		genarch/src/ofw/ofw_tree.c
+endif
+
+ifeq ($(CONFIG_OFW_PCI),y)
+	GENARCH_SOURCES += \
 		genarch/src/ofw/ebus.c \
 		genarch/src/ofw/fhc.c \
 		genarch/src/ofw/pci.c  \
 		genarch/src/ofw/sbus.c \
-		genarch/src/ofw/upa.c 
+		genarch/src/ofw/upa.c
 endif
 
Index: kernel/genarch/include/fb/fb.h
===================================================================
--- kernel/genarch/include/fb/fb.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/include/fb/fb.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -68,5 +68,5 @@
 
 void fb_redraw(void);
-void fb_init(fb_properties_t *props);
+bool fb_init(fb_properties_t *props);
 
 #endif
Index: kernel/genarch/include/fb/visuals.h
===================================================================
--- kernel/genarch/include/fb/visuals.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/include/fb/visuals.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -37,4 +37,5 @@
 
 typedef enum {
+	VISUAL_UNKNOWN = 0,
 	VISUAL_INDIRECT_8,
 	VISUAL_RGB_5_5_5_LE,
Index: kernel/genarch/include/ofw/ebus.h
===================================================================
--- kernel/genarch/include/ofw/ebus.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
+++ kernel/genarch/include/ofw/ebus.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -0,0 +1,72 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef KERN_EBUS_H_
+#define KERN_EBUS_H_
+
+#include <genarch/ofw/ofw_tree.h>
+#include <arch/types.h>
+#include <ddi/irq.h>
+#include <typedefs.h>
+
+typedef struct {
+	uint32_t space;
+	uint32_t addr;
+	uint32_t size;
+} __attribute__ ((packed)) ofw_ebus_reg_t;
+
+typedef struct {
+	uint32_t child_space;
+	uint32_t child_base;
+	uint32_t parent_space;
+	
+	/* Group phys.mid and phys.lo together */
+	uint64_t parent_base;
+	uint32_t size;
+} __attribute__ ((packed)) ofw_ebus_range_t;
+
+typedef struct {
+	uint32_t space;
+	uint32_t addr;
+	uint32_t intr;
+	uint32_t controller_handle;
+	uint32_t controller_ino;
+} __attribute__ ((packed)) ofw_ebus_intr_map_t;
+
+typedef struct {
+	uint32_t space_mask;
+	uint32_t addr_mask;
+	uint32_t intr_mask;
+} __attribute__ ((packed)) ofw_ebus_intr_mask_t;
+
+extern bool ofw_ebus_apply_ranges(ofw_tree_node_t *, ofw_ebus_reg_t *,
+    uintptr_t *);
+extern bool ofw_ebus_map_interrupt(ofw_tree_node_t *, ofw_ebus_reg_t *,
+    uint32_t, int *, cir_t *, void **);
+
+#endif
Index: kernel/genarch/include/ofw/fhc.h
===================================================================
--- kernel/genarch/include/ofw/fhc.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
+++ kernel/genarch/include/ofw/fhc.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -0,0 +1,67 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef KERN_FHC_H_
+#define KERN_FHC_H_
+
+#include <genarch/ofw/ofw_tree.h>
+#include <arch/types.h>
+#include <ddi/irq.h>
+#include <typedefs.h>
+
+typedef struct {
+	uint64_t addr;
+	uint32_t size;
+} __attribute__ ((packed)) ofw_fhc_reg_t;
+
+typedef struct {
+	uint64_t child_base;
+	uint64_t parent_base;
+	uint32_t size;
+} __attribute__ ((packed)) ofw_fhc_range_t;
+
+typedef struct {
+	uint64_t addr;
+	uint32_t size;
+} __attribute__ ((packed)) ofw_central_reg_t;
+
+typedef struct {
+	uint64_t child_base;
+	uint64_t parent_base;
+	uint32_t size;
+} __attribute__ ((packed)) ofw_central_range_t;
+
+extern bool ofw_fhc_apply_ranges(ofw_tree_node_t *, ofw_fhc_reg_t *,
+    uintptr_t *);
+extern bool ofw_central_apply_ranges(ofw_tree_node_t *, ofw_central_reg_t *,
+    uintptr_t *);
+
+extern bool ofw_fhc_map_interrupt(ofw_tree_node_t *, ofw_fhc_reg_t *,
+    uint32_t, int *, cir_t *, void **);
+
+#endif
